/* rtb_1102.p -- Integrity Check Report */


/* Define SHARED */
{rtb/g/rtbglobl.i}

DEFINE     SHARED BUFFER Brtb_hist FOR rtb.rtb_hist.

/* Define NEW SHARED */

/* Define Local */
{rtb/g/rtbrptv.i} /* print destination variables */

DEFINE NEW SHARED BUFFER Brtb_dbase             FOR rtb.rtb_dbase.
DEFINE NEW SHARED BUFFER B_db                   FOR DICTDB._db.

DEFINE            BUFFER Brtb_sequence          FOR rtb.rtb_sequence.
DEFINE            BUFFER Brtb_fldtrig           FOR rtb.rtb_fldtrig.
DEFINE            BUFFER Brtb_filtrig           FOR rtb.rtb_filtrig.

DEFINE            BUFFER B_field-trig           FOR DICTDB._field-trig.
DEFINE            BUFFER B_file-trig            FOR DICTDB._file-trig.
DEFINE            BUFFER B_sequence             FOR DICTDB._sequence.

DEFINE            BUFFER Brtb_object            FOR rtb.rtb_object.
DEFINE            BUFFER Brtb_dbfile            FOR rtb.rtb_dbfile.
DEFINE            BUFFER Brtb_file              FOR rtb.rtb_file.
DEFINE            BUFFER Brtb_field             FOR rtb.rtb_field.
DEFINE            BUFFER Brtb_flddef            FOR rtb.rtb_flddef.
DEFINE            BUFFER Brtb_index             FOR rtb.rtb_index.
DEFINE            BUFFER Brtb_idxfld            FOR rtb.rtb_idxfld.

DEFINE            BUFFER B_file                 FOR DICTDB._file.
DEFINE            BUFFER B_field                FOR DICTDB._field.
DEFINE            BUFFER B_index                FOR DICTDB._index.
DEFINE            BUFFER B_index-field          FOR DICTDB._index-field.


DEFINE            VARIABLE Ms                   AS INTEGER   NO-UNDO.
DEFINE            VARIABLE Mfile-pmod           AS CHARACTER NO-UNDO.
DEFINE            VARIABLE Mfile-version        AS INTEGER   NO-UNDO.
DEFINE            VARIABLE Mfile-upd-status     AS CHARACTER NO-UNDO.
DEFINE            VARIABLE Merror               AS CHARACTER NO-UNDO.
DEFINE            VARIABLE Mflddef-pmod         AS CHARACTER NO-UNDO.
DEFINE            VARIABLE Mflddef-version      AS INTEGER   NO-UNDO.
DEFINE            VARIABLE Mflddef-upd-status   AS CHARACTER NO-UNDO.
DEFINE            VARIABLE Mindex-field-problem AS LOGICAL   NO-UNDO.

DEFINE             VARIABLE MhFldBuff           AS HANDLE    NO-UNDO.

/* Define same_string function for case & accent sensitive string comparisons. */
{rtb/x/rtb_scmp.i}

/* Define schema storage area constants and functions */
{rtb/i/rtb_scharea.i}

/* End of Defines */    


IF SESSION:DISPLAY-TYPE = "TTY" THEN DO:
   DISPLAY
      ""
   WITH FRAME report-frame
      ROW 5
      COLUMN 10 
      TITLE " Database Integrity Check Report - rtb_1102.p ".
END.  /* if session:display-type = tty */


{rtb/g/rtbrpt1.i} /* Set print destination */

FIND Brtb_object 
   WHERE Brtb_object.wspace-id = Brtb_hist.wspace-id
     AND Brtb_object.obj-type  = Brtb_hist.obj-type
     AND Brtb_object.object    = Brtb_hist.object
     AND Brtb_object.pmod      = Brtb_hist.pmod
     AND Brtb_object.version   = Brtb_hist.version
     NO-LOCK NO-ERROR.

IF NOT AVAILABLE Brtb_object THEN DO:
   BELL.
   MESSAGE "Can only check integrity of Current Database Object.".
   {rtb/g/rtbpause.i}
   RETURN.
END.

/* Ensure that there is a database to check this PDBASE object against. */
FIND rtb.rtb_dbparam
   WHERE rtb.rtb_dbparam.wspace-id = Brtb_object.wspace-id
     AND rtb.rtb_dbparam.obj-type  = Brtb_object.obj-type
     AND rtb.rtb_dbparam.object    = Brtb_object.object
   NO-LOCK NO-ERROR.
IF NOT AVAILABLE rtb.rtb_dbparam THEN DO:
   BELL.
   MESSAGE "PDBASE object is lacking a parameters record.  Try deleting and " +
           "adding or assigning the PDBASE object back into the workspace.".
   {rtb/g/rtbpause.i}
   RETURN.
END.
ELSE
   IF rtb.rtb_dbparam.rtb_db-addr = "" OR rtb.rtb_dbparam.rtb_db-addr = ? THEN DO:
      BELL.
      MESSAGE "There is no Progress database to check this PDBASE object against." +
              "  Enter a physical name for the PDBASE object and try again.".
      {rtb/g/rtbpause.i}
      RETURN.
   END.

FIND Brtb_dbase 
   WHERE Brtb_dbase.pmod     = Brtb_object.committed-pmod
     AND Brtb_dbase.obj-type = Brtb_object.obj-type
     AND Brtb_dbase.object   = Brtb_object.object
     AND Brtb_dbase.version  = Brtb_object.committed-version
     NO-LOCK.

/* --- Get appropriate _Db record --- */
FIND B_db WHERE B_db._Db-name = Brtb_dbase.object
  NO-LOCK NO-ERROR.
IF NOT AVAILABLE B_db THEN
  FIND B_db WHERE B_db._Db-name = ? NO-LOCK NO-ERROR.
IF NOT AVAILABLE B_db THEN
  FIND FIRST B_db NO-LOCK.

{rtb/x/rtb_rpthdr.i 
    &title="""Database Integrity Check Report"""
    &crtieria="""Workspace : "" Grtb-wspace-id SKIP
               ""Database  : "" Brtb_dbase.OBJECT FORMAT ""x(32)"""
    &center-criteria=NO}

/* Processing for sequences */

SEQUENCE-LOOP:
FOR EACH Brtb_sequence OF Brtb_dbase NO-LOCK:
   PUT UNFORMATTED "Checking sequence: " Brtb_sequence.rtb_seq-name
       "." FORMAT "x(78)" SKIP.

   FIND B_sequence OF B_db
      WHERE B_sequence._seq-name = Brtb_sequence.rtb_seq-name NO-LOCK NO-ERROR.

   IF NOT AVAILABLE B_sequence THEN DO:
      PUT UNFORMATTED "Sequence: " 
          Brtb_sequence.rtb_seq-name
          " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
      NEXT SEQUENCE-LOOP.
   END.
   
   IF Brtb_sequence.rtb_seq-name <> B_sequence._seq-name THEN
      PUT UNFORMATTED "_seq-name: " STRING(B_sequence._seq-name)
          " should be: " STRING(Brtb_sequence.rtb_seq-name) "."
          FORMAT "x(78)" SKIP.   

   IF Brtb_sequence.rtb_cycle-ok <> B_sequence._cycle-ok THEN
      PUT UNFORMATTED "_cycle-ok: " STRING(B_sequence._cycle-ok)
          " should be: " STRING(Brtb_sequence.rtb_cycle-ok) "."
          FORMAT "x(78)" SKIP.

   IF Brtb_sequence.rtb_seq-incr <> B_sequence._seq-incr THEN
      PUT UNFORMATTED "_seq-incr: " STRING(B_sequence._seq-incr)
          " should be: " STRING(Brtb_sequence.rtb_seq-incr) "."
          FORMAT "x(78)" SKIP.

   IF Brtb_sequence.rtb_seq-init <> B_sequence._seq-init THEN
      PUT UNFORMATTED "_seq-init: " STRING(B_sequence._seq-init)
          " should be: " STRING(Brtb_sequence.rtb_seq-init) "."
          FORMAT "x(78)" SKIP.

   IF Brtb_sequence.rtb_seq-max <> B_sequence._seq-max THEN
      PUT UNFORMATTED "_seq-max: " 
          (IF B_sequence._seq-max = ? 
             THEN "?" 
             ELSE STRING(B_sequence._seq-max))
          " should be: " 
          (IF Brtb_sequence.rtb_seq-max = ? 
             THEN "?"
             ELSE STRING(Brtb_sequence.rtb_seq-max)) "."
          FORMAT "x(78)" SKIP.

   IF Brtb_sequence.rtb_seq-min <> B_sequence._seq-min THEN
      PUT UNFORMATTED "_seq-min: " 
          (IF B_sequence._seq-min = ?
             THEN "?"
             ELSE STRING(B_sequence._seq-min))
          " should be: " 
          (IF Brtb_sequence.rtb_seq-min = ? 
             THEN "?"
             ELSE STRING(Brtb_sequence.rtb_seq-min)) "."
          FORMAT "x(78)" SKIP.

END.  /* for each brtb_sequence */

SEQUENCE-LOOP:
FOR EACH B_sequence OF B_db NO-LOCK:
   FIND Brtb_sequence OF Brtb_dbase
      WHERE Brtb_sequence.rtb_seq-name = B_sequence._seq-name NO-LOCK NO-ERROR.

   IF NOT AVAILABLE Brtb_sequence THEN DO:
      PUT UNFORMATTED "Sequence: " 
          B_sequence._seq-name
          " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
      NEXT SEQUENCE-LOOP.
   END.
END.  /* for each b_sequence */


FILE-LOOP:
FOR EACH Brtb_dbfile OF Brtb_dbase NO-LOCK:

   PUT UNFORMATTED "Checking file: " 
       Brtb_dbfile.local-file-name "." FORMAT "x(78)" SKIP.

   FIND B_file OF B_Db
      WHERE B_file._file-name = Brtb_dbfile.local-file-name
        AND B_file._DB-lang   = 0 NO-LOCK NO-ERROR.
   
   IF NOT AVAILABLE B_file THEN DO:
      PUT UNFORMATTED "File: " 
          Brtb_dbfile.local-file-name 
          " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
      NEXT FILE-LOOP.
   END.

   RUN rtb/p/rtb_gver.p /* Get version and pmod of file */
      (-2,
       Brtb_dbfile.file-obj-type,
       Brtb_dbfile.file-object,
       OUTPUT Mfile-pmod,
       OUTPUT Mfile-version,
       OUTPUT Mfile-upd-status,
       OUTPUT Merror).

   FIND Brtb_file
      WHERE Brtb_file.obj-type   = Brtb_dbfile.file-obj-type
        AND Brtb_file.object     = Brtb_dbfile.file-object
        AND Brtb_file.pmod       = Mfile-pmod
        AND Brtb_file.version    = Mfile-version
        NO-LOCK.

   /* Compare File Header */
   IF Brtb_file.rtb_hidden   <> B_file._hidden THEN
      PUT UNFORMATTED "_hidden: " 
          STRING(B_file._hidden)
          " should be: " 
          STRING(Brtb_file.rtb_hidden) "."
          FORMAT "x(78)" SKIP.

   IF Brtb_file.rtb_frozen   <> B_file._frozen THEN
      PUT UNFORMATTED "_frozen: " 
          STRING(B_file._frozen)
          " should be: " 
          STRING(Brtb_file.rtb_frozen) "."
          FORMAT "x(78)" SKIP.

   IF NOT same_string(Brtb_file.rtb_dump-name, B_file._dump-name) THEN
      PUT UNFORMATTED "_dump-name: " B_file._dump-name 
          " should be: " Brtb_file.rtb_dump-name "."
          FORMAT "x(78)" SKIP.

   IF NOT same_string(Brtb_file.rtb_fil-misc2[6], B_file._fil-misc2[6]) THEN
      PUT UNFORMATTED "_fil-misc2[6] (Replication): " B_file._fil-misc2[6] 
          " should be: " Brtb_file.rtb_fil-misc2[6] "."
          FORMAT "x(78)" SKIP.

   IF NOT same_string(Brtb_file.rtb_valexp, B_file._valexp) THEN DO:
      
      PUT UNFORMATTED "_valexp: "  FORMAT "x(78)" SKIP.
      DO Ms = 1 TO LENGTH(B_file._valexp) BY 76:
         PUT UNFORMATTED SUBSTRING(B_file._valexp,Ms,76) FORMAT "x(78)" SKIP.
      END.

      PUT UNFORMATTED "should be:" FORMAT "x(78)" SKIP.
      DO Ms = 1 TO LENGTH(Brtb_file.rtb_valexp) BY 76:
         PUT UNFORMATTED SUBSTRING(Brtb_file.rtb_valexp,Ms,76) "."
             FORMAT "x(78)" SKIP.
      END.
   END.

   IF NOT same_string(Brtb_file.rtb_valmsg, B_file._valmsg) THEN
      PUT UNFORMATTED "_valmsg: "  SKIP
          B_file._valmsg FORMAT "x(78)" SKIP
          "should be: " SKIP
          Brtb_file.rtb_valmsg "." FORMAT "x(78)" SKIP.

   IF Brtb_dbfile.area-name <> 
      getStorageAreaName({&TABLE-OBJECT},B_File._File-num) THEN
     PUT UNFORMATTED "Storage Area:"
       getStorageAreaName({&TABLE-OBJECT}, B_File._File-num)
       " should be: " Brtb_dbfile.area-name
       FORMAT "x(78)" SKIP.
   
   IF NOT same_string(Brtb_file.rtb_desc, B_file._desc) THEN
      PUT UNFORMATTED "_desc:"  SKIP
          B_file._desc FORMAT "x(78)" SKIP
          "should be: " SKIP
          Brtb_file.rtb_desc "." FORMAT "x(78)" SKIP.

  
   IF NOT same_string(Brtb_file.rtb_file-label, B_file._file-label) THEN   
      PUT UNFORMATTED "_file-label:" B_file._file-label FORMAT "x(78)" SKIP
          "  should be:" Brtb_file.rtb_file-label "." FORMAT "x(78)" SKIP.

   IF Brtb_file.rtb_file-label-sa <> B_file._file-label-sa THEN
      PUT UNFORMATTED "_file-label-sa: " B_file._file-label-sa 
            " should be: " Brtb_file.rtb_file-label-sa "."
          FORMAT "x(78)" SKIP.

   IF Brtb_file.rtb_valmsg-sa  <> B_file._valmsg-sa THEN
      PUT UNFORMATTED "_valmsg-sa: " B_file._valmsg-sa
            " should be: " Brtb_file.rtb_valmsg-sa "."
          FORMAT "x(78)" SKIP.

   /* Processing for file triggers */
   FILETRIG-LOOP:
   FOR EACH Brtb_filtrig OF Brtb_file NO-LOCK:
      FIND B_file-trig OF B_file
         WHERE B_file-trig._event = Brtb_filtrig.rtb_event NO-LOCK NO-ERROR.
      IF NOT AVAILABLE B_file-trig THEN DO:
         PUT UNFORMATTED "File: " Brtb_dbfile.local-file-name
             " trigger: " Brtb_filtrig.rtb_event
             " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
         NEXT FILETRIG-LOOP.
      END.

      IF B_file-trig._override <> Brtb_filtrig.rtb_override OR
         (NOT same_string(B_file-trig._proc-name, Brtb_filtrig.rtb_proc-name)) THEN
         PUT UNFORMATTED "Trigger: " B_file-trig._event FORMAT "x(78)" SKIP.

      IF B_file-trig._override <> Brtb_filtrig.rtb_override THEN
         PUT UNFORMATTED "_override: " STRING(B_file-trig._override)
             " should be: " STRING(Brtb_filtrig.rtb_override) "."
             FORMAT "x(78)" SKIP.
        
      IF NOT same_string(B_file-trig._proc-name, Brtb_filtrig.rtb_proc-name) THEN
         PUT UNFORMATTED "_proc-name: " B_file-trig._proc-name FORMAT "x(78)" SKIP
             " should be: " Brtb_filtrig.rtb_proc-name "."
             FORMAT "x(78)" SKIP.

   END. /* of FILETRIG-LOOP */

   FOR EACH B_file-trig OF B_file NO-LOCK:
      FIND Brtb_filtrig OF Brtb_file
         WHERE Brtb_filtrig.rtb_event = B_file-trig._event NO-LOCK NO-ERROR.

      IF NOT AVAILABLE Brtb_filtrig THEN
         PUT UNFORMATTED "File: " B_file._file-name
             " trigger: " B_file-trig._event
             " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
   END.


   /* Check each field in file */

   FIELD-LOOP:
   FOR EACH Brtb_field OF Brtb_file NO-LOCK:

      FIND B_field OF B_file
         WHERE B_field._field-name = Brtb_field.local-field-name
         NO-LOCK NO-ERROR.

      IF NOT AVAILABLE B_field THEN DO:
         PUT UNFORMATTED "Field: " 
             Brtb_dbfile.local-file-name "." Brtb_field.local-field-name
             " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
         NEXT FIELD-LOOP.
      END.

      MhFldBuff = BUFFER B_field:HANDLE.

      RUN rtb/p/rtb_gver.p /* Get version and pmod of field */
         (-2,
          Brtb_field.flddef-obj-type,
          Brtb_field.flddef-object,
          OUTPUT Mflddef-pmod,
          OUTPUT Mflddef-version,
          OUTPUT Mflddef-upd-status,
          OUTPUT Merror).

      FIND Brtb_flddef 
         WHERE Brtb_flddef.pmod     = Mflddef-pmod
           AND Brtb_flddef.obj-type = Brtb_field.flddef-obj-type
           AND Brtb_flddef.object   = Brtb_field.flddef-object
           AND Brtb_flddef.version  = Mflddef-version
           NO-LOCK.

      IF Brtb_field.rtb_order         <> B_field._order
      OR Brtb_field.rtb_mandatory     <> B_field._mandatory
      OR Brtb_flddef.rtb_data-type    <> B_field._data-type
      OR (NOT same_string(Brtb_flddef.rtb_initial, B_field._initial))
      OR (NOT same_string(Brtb_flddef.rtb_label,   B_field._label))
      OR (NOT same_string(Brtb_flddef.rtb_format,  B_field._format))
      OR Brtb_flddef.rtb_decimals     <> B_field._decimals
      OR Brtb_flddef.rtb_extent       <> B_field._extent
      OR (NOT same_string(Brtb_flddef.rtb_valexp,  B_field._valexp))
      OR (NOT same_string(Brtb_flddef.rtb_valmsg,  B_field._valmsg))
      OR (NOT same_string(Brtb_flddef.rtb_help,    B_field._help))
      OR (NOT same_string(Brtb_flddef.rtb_desc,    B_field._desc))
      OR (NOT same_string(Brtb_flddef.rtb_col-label, B_field._col-label))
      OR Brtb_flddef.rtb_fld-case     <> B_field._fld-case
      OR (NOT same_string(Brtb_flddef.rtb_view-as, B_field._view-as))
      OR Brtb_flddef.rtb_col-label-sa <> B_field._col-label-sa
      OR Brtb_flddef.rtb_format-sa    <> B_field._format-sa
      OR Brtb_flddef.rtb_help-sa      <> B_field._help-sa
      OR Brtb_flddef.rtb_initial-sa   <> B_field._initial-sa
      OR Brtb_flddef.rtb_label-sa     <> B_field._label-sa
      OR Brtb_flddef.rtb_valmsg-sa    <> B_field._valmsg-sa
      OR Brtb_flddef.rtb_Width        <> B_field._width
      OR (B_field._Data-type MATCHES ".LOB" 
          AND Brtb_field.area-name <> getStorageAreaName({&LOB-OBJECT},
                                                         B_field._Fld-stlen))
      OR (INTEGER(DBVERSION("DICTDB":U)) > 9
          AND B_field._Data-type = "CLOB":U
         AND
         (Brtb_field.rtb_Attributes1  <> MhFldBuff:BUFFER-FIELD("_Attributes1":U):BUFFER-VALUE
          OR Brtb_field.rtb_Charset   <> MhFldBuff:BUFFER-FIELD("_Charset":U):BUFFER-VALUE
          OR Brtb_field.rtb_Collation <> MhFldBuff:BUFFER-FIELD("_Collation":U):BUFFER-VALUE)
          OR Brtb_flddef.rtb_Fld-misc2[1] <> MhFldBuff:BUFFER-FIELD("_Fld-misc2":U):BUFFER-VALUE(1))
      THEN DO:
         PUT UNFORMATTED B_field._field-name SKIP.

         IF Brtb_field.rtb_order <> B_field._order THEN 
            PUT UNFORMATTED "   _order: " STRING(B_field._order)
                " should be: "
                STRING(Brtb_field.rtb_order) "." FORMAT "x(78)" SKIP.

         IF Brtb_field.rtb_mandatory <> B_field._mandatory THEN
            PUT UNFORMATTED "_mandatory " STRING(B_field._mandatory) 
                " should be: "
                STRING(Brtb_field.rtb_mandatory) "." FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_data-type   <> B_field._data-type THEN
            PUT UNFORMATTED "_data-type: " B_field._data-type
                " should be: " Brtb_flddef.rtb_data-type "."
                FORMAT "x(78)" SKIP.

         IF NOT same_string(Brtb_flddef.rtb_initial, B_field._initial) THEN
            PUT UNFORMATTED " _initial: " B_field._initial FORMAT "x(78)" SKIP
                "should be: " Brtb_flddef.rtb_initial "." FORMAT "x(78)" SKIP.

         IF NOT same_string(Brtb_flddef.rtb_label, B_field._label) THEN
            PUT UNFORMATTED "   _label: " B_field._label FORMAT "x(78)" SKIP
                "should be: " Brtb_flddef.rtb_label "." FORMAT "x(78)" SKIP.

         IF NOT same_string(Brtb_flddef.rtb_format, B_field._format) THEN
            PUT UNFORMATTED "  _format: " B_field._format FORMAT "x(78)" SKIP
                "should be: " Brtb_flddef.rtb_format "." FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_decimals     <> B_field._decimals THEN
            PUT UNFORMATTED "_decimals:" (IF B_field._decimals = ? 
                                THEN "?"  
                                ELSE STRING(B_field._decimals))
                " should be:" (IF Brtb_flddef.rtb_decimals = ?
                                   THEN "?"
                                   ELSE STRING(Brtb_flddef.rtb_decimals)) "."
                FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_extent     <> B_field._extent THEN
            PUT UNFORMATTED "_extent:" (IF B_field._extent = ? 
                              THEN "?"  
                              ELSE STRING(B_field._extent))
                " should be:" (IF Brtb_flddef.rtb_extent = ?
                                   THEN "?"
                                   ELSE STRING(Brtb_flddef.rtb_extent)) "."
                FORMAT "x(78)" SKIP.

         IF B_Field._Data-Type MATCHES ".LOB"
            AND Brtb_field.area-name 
                <> getStorageAreaName({&LOB-OBJECT},B_field._Fld-stlen) THEN
           PUT UNFORMATTED
             "Storage Area:"
             getStorageAreaName({&LOB-OBJECT}, B_field._Fld-stlen)
             " should be:" Brtb_field.area-name
             FORMAT "x(78)" SKIP.
         
         IF INTEGER(DBVERSION("DICTDB":U)) > 9 AND B_field._Data-type = "CLOB":U THEN DO:
           IF Brtb_field.rtb_Attributes1 <> MhFldBuff:BUFFER-FIELD("_Attributes1":U):BUFFER-VALUE THEN
             PUT UNFORMATTED "_Attributes1:"
                                STRING(MhFldBuff:BUFFER-FIELD("_Attributes1":U):BUFFER-VALUE)
                 " should be:"  STRING(Brtb_field.rtb_Attributes1) "."
                 FORMAT "x(78)" SKIP.

           IF Brtb_field.rtb_Charset <> MhFldBuff:BUFFER-FIELD("_Charset":U):BUFFER-VALUE THEN
             PUT UNFORMATTED "Code Page:"
                                STRING(MhFldBuff:BUFFER-FIELD("_Charset":U):BUFFER-VALUE)
                 " should be:"  STRING(Brtb_field.rtb_Charset) "."
                 FORMAT "x(78)" SKIP.

           IF Brtb_field.rtb_Collation <> MhFldBuff:BUFFER-FIELD("_Collation":U):BUFFER-VALUE THEN
             PUT UNFORMATTED "Collation:"
                                STRING(MhFldBuff:BUFFER-FIELD("_Collation":U):BUFFER-VALUE)
                 " should be:"  STRING(Brtb_field.rtb_Collation) "."
                 FORMAT "x(78)" SKIP.

           IF Brtb_flddef.rtb_Fld-misc2[1] <> MhFldBuff:BUFFER-FIELD("_Fld-misc2":U):BUFFER-VALUE(1) THEN
             PUT UNFORMATTED "Max Size:"
                               STRING(MhFldBuff:BUFFER-FIELD("_Fld-misc2":U):BUFFER-VALUE(1))
                 " should be:"  STRING(Brtb_flddef.rtb_Fld-misc2[1]) "."
                 FORMAT "x(78)" SKIP.
         END. /* CLOB */

         IF Brtb_flddef.rtb_Width <> B_field._width THEN DO:
           PUT UNFORMATTED "_width:"
                            STRING(B_field._width)
               " should be:" STRING(Brtb_flddef.rtb_width) "."
               FORMAT "x(78)" SKIP.
         END.

         IF NOT same_string(Brtb_flddef.rtb_valexp, B_field._valexp) THEN DO:
            PUT UNFORMATTED "_valexp:" SKIP.
            DO Ms = 1 TO LENGTH(B_field._valexp) BY 76:
               PUT UNFORMATTED SUBSTRING(B_field._valexp,Ms,76) FORMAT "x(78)" SKIP.
            END.
            PUT UNFORMATTED "should be:" SKIP.
            DO Ms = 1 TO LENGTH(Brtb_flddef.rtb_valexp) BY 76:
               PUT UNFORMATTED SUBSTRING(Brtb_flddef.rtb_valexp,Ms,76) "."
                   FORMAT "x(78)" SKIP.
            END.
         END.

         IF NOT same_string(Brtb_flddef.rtb_valmsg, B_field._valmsg) THEN
            PUT UNFORMATTED "_valmsg:" SKIP
                B_field._valmsg SKIP
                "should be:" SKIP
                Brtb_flddef.rtb_valmsg "." SKIP.

         IF NOT same_string(Brtb_flddef.rtb_help, B_field._help) THEN
            PUT UNFORMATTED "_help: " SKIP
                B_field._help SKIP
                "should be:" SKIP 
                Brtb_flddef.rtb_help "." SKIP.

         IF NOT same_string(Brtb_flddef.rtb_desc, B_field._desc) THEN
            PUT UNFORMATTED "_desc:" SKIP
                B_field._desc SKIP
                "should be:" SKIP
                Brtb_flddef.rtb_desc "." SKIP.

         IF NOT same_string(Brtb_flddef.rtb_col-label, B_field._col-label) THEN
            PUT UNFORMATTED "_col-label: " B_field._col-label FORMAT "x(78)" SKIP
                " should be: " Brtb_flddef.rtb_col-label "."
                FORMAT "x(78)" SKIP.  
       
         IF Brtb_flddef.rtb_fld-case     <> B_field._fld-case THEN
            PUT UNFORMATTED "_fld-case: " 
                STRING(B_field._fld-case,"Sensitive/Not-Sensitive")
                " should be: " 
                STRING(Brtb_flddef.rtb_fld-case,"Sensitive/Not-Sensitive")
                "."
                FORMAT "x(78)" SKIP.


         IF NOT same_string(Brtb_flddef.rtb_view-as, B_field._view-as) THEN DO:
            PUT UNFORMATTED "_view-as:" SKIP.
            DO Ms = 1 TO LENGTH(B_field._view-as) BY 76:
               PUT UNFORMATTED SUBSTRING(B_field._view-as,Ms,76) FORMAT "x(78)" SKIP.
            END.

            PUT UNFORMATTED "should be:" SKIP.
            DO Ms = 1 TO LENGTH(Brtb_flddef.rtb_view-as) BY 76:
               PUT UNFORMATTED SUBSTRING(Brtb_flddef.rtb_view-as,Ms,76) "."
                   FORMAT "x(78)" SKIP.
            END.
         END.

         IF Brtb_flddef.rtb_col-label-sa <> B_field._col-label-sa THEN
            PUT UNFORMATTED "_col-label-sa: " (IF B_field._col-label-sa = ?
                                     THEN "?" ELSE B_field._col-label-sa)
                " should be: " (IF Brtb_flddef.rtb_col-label-sa = ?
                                    THEN "?" ELSE Brtb_flddef.rtb_col-label-sa)
                "."
                FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_format-sa <> B_field._format-sa THEN
            PUT UNFORMATTED "_format-sa: " (IF B_field._format-sa = ?
                                  THEN "?" ELSE B_field._format-sa)
                " should be: " (IF Brtb_flddef.rtb_format-sa = ?
                                    THEN "?" ELSE Brtb_flddef.rtb_format-sa)
                "."
                FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_help-sa <> B_field._help-sa THEN
            PUT UNFORMATTED "_help-sa: " (IF B_field._help-sa = ?
                                THEN "?" ELSE B_field._help-sa)
                " should be: " (IF Brtb_flddef.rtb_help-sa = ?
                                    THEN "?" ELSE Brtb_flddef.rtb_help-sa) "."
                FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_initial-sa <> B_field._initial-sa THEN
            PUT UNFORMATTED "_initial-sa: " (IF B_field._initial-sa = ?
                                   THEN "?" ELSE B_field._initial-sa)
                " should be: " (IF Brtb_flddef.rtb_initial-sa = ?
                                    THEN "?" ELSE Brtb_flddef.rtb_initial-sa)
                "."
                FORMAT "x(78)" SKIP.

         IF Brtb_flddef.rtb_label-sa <> B_field._label-sa THEN
            PUT UNFORMATTED "_label-sa: " (IF B_field._label-sa = ?
                                 THEN "?" ELSE B_field._label-sa)
                " should be: " (IF Brtb_flddef.rtb_label-sa = ?
                                    THEN "?" ELSE Brtb_flddef.rtb_label-sa)
                "."
                FORMAT "x(78)" SKIP.


         IF Brtb_flddef.rtb_valmsg-sa <> B_field._valmsg-sa THEN
            PUT UNFORMATTED "_valmsg-sa: " (IF B_field._valmsg-sa = ?
                                  THEN "?" ELSE B_field._valmsg-sa)
                " should be: " (IF Brtb_flddef.rtb_valmsg-sa = ?
                                    THEN "?" ELSE Brtb_flddef.rtb_valmsg-sa)
                "."
                FORMAT "x(78)" SKIP.
    
      END. /* Difference in field */

      /* Processing for field level triggers */

      FIELDTRIG-LOOP:
      FOR EACH Brtb_fldtrig OF Brtb_field NO-LOCK:
         FIND B_field-trig OF B_field
            WHERE B_field-trig._event = Brtb_fldtrig.rtb_event NO-LOCK NO-ERROR.
         IF NOT AVAILABLE B_field-trig THEN DO:
            PUT UNFORMATTED "Field: " Brtb_dbfile.local-file-name "."
                Brtb_field.local-field-name
                " trigger: " Brtb_fldtrig.rtb_event 
                " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
            NEXT FIELDTRIG-LOOP.
         END.

         IF B_field-trig._override <> Brtb_fldtrig.rtb_override
         OR (NOT same_string(B_field-trig._proc-name, Brtb_fldtrig.rtb_proc-name)) THEN
            PUT UNFORMATTED "Trigger: " B_field-trig._event FORMAT "x(78)" SKIP.

         IF B_field-trig._override <> Brtb_fldtrig.rtb_override THEN
            PUT UNFORMATTED "_override: " STRING(B_field-trig._override)
                " should be: " STRING(Brtb_fldtrig.rtb_override)
                "." FORMAT "x(78)" SKIP.
           
         IF NOT same_string(B_field-trig._proc-name, Brtb_fldtrig.rtb_proc-name) THEN
            PUT UNFORMATTED "_proc-name: " B_field-trig._proc-name FORMAT "x(78)" SKIP
                " should be: " Brtb_fldtrig.rtb_proc-name "."
                FORMAT "x(78)" SKIP.

      END. /* of FILETRIG-LOOP */

      FOR EACH B_field-trig OF B_field NO-LOCK:
         FIND Brtb_fldtrig OF Brtb_field
            WHERE Brtb_fldtrig.rtb_event = B_field-trig._event NO-LOCK NO-ERROR.

         IF NOT AVAILABLE Brtb_fldtrig THEN
            PUT UNFORMATTED "Field: " B_file._file-name "."
                B_field._field-name
                " trigger: " B_field-trig._event
                " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
      END.

   END. /* of EACH Brtb_field */

   FOR EACH B_field OF B_file NO-LOCK:
      FIND Brtb_field OF Brtb_file
         WHERE Brtb_field.local-field-name = B_field._field-name
         NO-LOCK NO-ERROR.

      IF NOT AVAILABLE Brtb_field THEN
         PUT UNFORMATTED "Field: " B_file._file-name "."
             B_field._field-name
             " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
   END.  /* for each b_field of b_file */

   /* Check indices */
   INDEX-LOOP:
   FOR EACH Brtb_index OF Brtb_file NO-LOCK:
      FIND B_index OF B_file 
         WHERE B_index._index-name = Brtb_index.rtb_index-name NO-LOCK NO-ERROR.

      IF NOT AVAILABLE B_index THEN DO:
         PUT UNFORMATTED "Index: " 
             Brtb_dbfile.local-file-name "." Brtb_index.rtb_index-name
             " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
         NEXT INDEX-LOOP.
      END.

      IF Brtb_index.rtb_unique         <> B_index._unique 
      OR Brtb_index.rtb_active         <> B_index._active 
      OR (Brtb_file.rtb_prime-index-id =  Brtb_index.index-id
          AND B_file._prime-index      <> RECID(B_index))
      OR (Brtb_index.area-name <> getStorageAreaName({&INDEX-OBJECT},                                                      B_index._idx-num))
      /* Processing for _index                                             */
      /* Note the special handling of word indices...                      */
      /* Progress indicates that an index is not a word index by setting   */
      /* the _wordidx field to be 0 or ?.  We must check for either value. */ 
      OR (NOT same_string(Brtb_index.rtb_desc, B_index._desc))
      OR (Brtb_index.rtb_wordidx      =  1 AND
          B_index._wordidx            <> 1)
      OR (Brtb_index.rtb_wordidx      <> 1 AND
          B_index._wordidx            =  1)
      THEN DO:
         PUT UNFORMATTED "Index: " 
           Brtb_index.rtb_index-name FORMAT "x(78)" SKIP.

         IF Brtb_index.rtb_unique       <> B_index._unique THEN
            PUT UNFORMATTED "_unique: " 
                STRING(B_index._unique,"Unique/Not-Unique")
                " should be: " 
                STRING(Brtb_index.rtb_unique,"Unique/Not-Unique") "."
                FORMAT "x(78)" SKIP.

         IF Brtb_index.rtb_active       <> B_index._active THEN
            PUT UNFORMATTED "_active: " 
                STRING(B_index._active,"Active/In-active")
                " should be: " 
                STRING(Brtb_index.rtb_active,"Active/In-active") "."
                FORMAT "x(78)" SKIP.

         IF Brtb_index.area-name <> getStorageAreaName({&INDEX-OBJECT},                                                        B_index._idx-num) THEN
           PUT UNFORMATTED "Storage Area: "
               getStorageAreaName({&INDEX-OBJECT}, B_index._idx-num)
               " should be: "
               Brtb_index.area-name "." FORMAT "x(78)" SKIP.
         
         IF Brtb_file.rtb_prime-index-id = Brtb_index.index-id
         AND B_file._prime-index <> RECID(B_index) THEN 
            PUT UNFORMATTED "Primary index in file: " 
                B_file._file-name  
                " should be "
                Brtb_index.rtb_index-name "." FORMAT "x(78)" SKIP.

         /* Index processing                                                  */
         /* Note the special handling of word indices...                      */
         /* Progress indicates that an index is not a word index by setting   */
         /* the _wordidx field to be 0 or ?.  We must check for either value. */
         IF NOT same_string(Brtb_index.rtb_desc, B_index._desc) THEN
            PUT UNFORMATTED "_desc: " B_index._desc FORMAT "x(78)" SKIP
                "should be: " Brtb_index.rtb_desc "." FORMAT "x(78)" SKIP.
         IF (Brtb_index.rtb_wordidx      =  1 AND
             B_index._wordidx            <> 1)
         OR (Brtb_index.rtb_wordidx      <> 1 AND
             B_index._wordidx            =  1)THEN
            PUT UNFORMATTED "_wordidx: " STRING(B_index._wordidx)
                " should be: " STRING(Brtb_index.rtb_wordidx) "."
                FORMAT "x(78)" SKIP.

      END. /* difference in _index */

      ASSIGN
         Mindex-field-problem = no.
      /* Check each index field assignment */
      INDEX-FIELD-LOOP:
      FOR EACH Brtb_idxfld OF Brtb_index NO-LOCK,
         Brtb_field OF Brtb_file
         WHERE Brtb_field.field-id = Brtb_idxfld.field-id NO-LOCK:

         FIND B_index-field OF B_index
            WHERE B_index-field._index-seq = Brtb_idxfld.rtb_index-seq
              NO-LOCK NO-ERROR.

         IF NOT AVAILABLE B_index-field THEN DO:
            PUT UNFORMATTED "Index: " 
                Brtb_dbfile.local-file-name
                "."
                Brtb_index.rtb_index-name
                " field: "
                Brtb_field.local-field-name
                " is not in Progress Dictionary." FORMAT "x(78)" SKIP.
            LEAVE INDEX-FIELD-LOOP.
         END.

         FIND B_field 
            WHERE RECID(B_field) = B_index-field._field-recid
              NO-LOCK.

         IF B_field._field-name      <> Brtb_field.local-field-name THEN DO:
            PUT UNFORMATTED "Index fields don't match in "
                B_file._file-name "." B_index._index-name "."
                FORMAT "x(78)" SKIP.
            ASSIGN
               Mindex-field-problem = yes.
            LEAVE INDEX-FIELD-LOOP.
         END.

         IF B_index-field._ascending  <> Brtb_idxfld.rtb_ascending THEN
            PUT UNFORMATTED "_Index-field._ascending in "
                B_file._file-name "." B_index._index-name 
                "." Brtb_field.local-field-name
                " should be "
                STRING(B_index-field._ascending,"Ascending/Descending") "."
                FORMAT "x(78)" SKIP.

         IF B_index-field._abbreviate <> Brtb_idxfld.rtb_abbreviate THEN
            PUT UNFORMATTED "_Index-field._abbreviate in "
                B_file._file-name "." B_index._index-name 
                "." Brtb_field.local-field-name
                " should be " 
                STRING(B_index-field._abbreviate,
                        "Abbreviated/Not-Abbreviated") "."
                FORMAT "x(78)" SKIP.

      END. /* of EACH Brtb_idxfld */

      IF Mindex-field-problem THEN 
         FOR EACH Brtb_idxfld OF Brtb_index NO-LOCK,
            Brtb_field OF Brtb_file
            WHERE Brtb_field.field-id = Brtb_idxfld.field-id NO-LOCK,
            B_index-field OF B_index
            WHERE B_index-field._index-seq = Brtb_idxfld.rtb_index-seq
            NO-LOCK:
            PUT UNFORMATTED "   "
                STRING(B_index-field._ascending,"+/-")
                " "
                Brtb_field.local-field-name
                " " 
                STRING(B_index-field._abbreviate,"Abbreviate/") "."
                FORMAT "x(78)" SKIP.
         END.

   END. /* of EACH Brtb_index */

   IF NOT B_file._dft-pk THEN DO:
     INDEX-LOOP2:
     FOR EACH B_index OF B_file NO-LOCK:
        FIND FIRST Brtb_index OF Brtb_file
           WHERE Brtb_index.rtb_index-name = B_index._index-name
           NO-LOCK NO-ERROR.

        IF NOT AVAILABLE Brtb_index THEN DO:
           PUT UNFORMATTED "Index: " 
               B_file._file-name "." B_index._index-name
               " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
           NEXT INDEX-LOOP2.
        END.

        FOR EACH B_index-field OF B_index NO-LOCK:

           FIND FIRST Brtb_idxfld OF Brtb_index
              WHERE Brtb_idxfld.rtb_index-seq = B_index-field._index-seq
                NO-LOCK NO-ERROR.

           IF NOT AVAILABLE Brtb_idxfld THEN DO:
              FIND FIRST B_field
                 WHERE RECID(B_field) = B_index-field._field-recid NO-LOCK.
              PUT UNFORMATTED "Index: " 
                  B_file._file-name
                  "."
                  B_index._index-name
                  " field: "
                  B_field._field-name
                  " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
           END.
        END.  /* for each b_index-field of b_index */
     END.  /* for each b_index of b_file */

   END. /* not b_file._dft-ok */
   
END. /* of EACH Brtb_dbfile */

/* Check that all files in Progress Dictionary exist in RTB 
   Note that we do not have to check fields etc because if the
   file exists this has already been done above! */
FILE-LOOP:
FOR EACH B_file OF B_db 
  WHERE B_file._DB-lang = 0                       /* filter-out SQL schema */
    AND (NOT B_file._file-name BEGINS "_")        /* filter-out metaschema */
    AND B_file._Tbl-type  = "T":U                 /* user "tables" */
    AND ((B_file._For-type = ?)                   /* native Progress */
          OR (B_file._For-type <> ?
              AND B_file._hidden = NO))           /* or dataserver schema */       NO-LOCK:

   FIND FIRST Brtb_dbfile OF Brtb_dbase
      WHERE Brtb_dbfile.local-file-name = B_file._file-name NO-LOCK NO-ERROR.

   IF NOT AVAILABLE Brtb_dbfile THEN DO:
      PUT UNFORMATTED "File: " 
          B_file._file-name 
          " is not in Roundtable Schema." FORMAT "x(78)" SKIP.
      NEXT FILE-LOOP.
   END.

END. /* of EACH B_file */

{rtb/g/rtbrpt2.i} /* close print destination */
